unit Unit3;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, FastBMP, FastFX;

type
  TForm3 = class(TForm)
    sRed: TScrollBar;
    sBlue: TScrollBar;
    sGreen: TScrollBar;
    sContrast: TScrollBar;
    sLightness: TScrollBar;
    sSaturation: TScrollBar;
    Label1: TLabel;
    Button1: TButton;
    procedure Button1Click(Sender: TObject);
    procedure FormShow(Sender: TObject);
    procedure sRedScroll(Sender: TObject; ScrollCode: TScrollCode;
      var ScrollPos: Integer);
    procedure FormHide(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
    procedure Process;
  end;

var
  Form3: TForm3;

implementation

uses Unit2;

{$R *.DFM}

procedure TForm3.Process;
var
pRed,
pBlue,
pGreen,
pContrast,
pLightness,
pSaturation: Integer;
begin
  CopyMemory(Form2.Bmp.Bits,Form2.Buf.Bits,Form2.Bmp.Size);
  pRed:=sRed.Position-255;
  pBlue:=sBlue.Position-255;
  pGreen:=sGreen.Position-255;
  pContrast:=sContrast.Position-255;
  pLightness:=sLightness.Position-255;
  pSaturation:=sSaturation.Position;
  if(pRed<>0)or(pBlue<>0)or(pGreen<>0)then
    RGB(Form2.Bmp,pRed,pBlue,pGreen);
  if pContrast<>0 then
    Contrast(Form2.Bmp,pContrast);
  if pLightness<>0 then
    Lightness(Form2.Bmp,pLightness);
  if pSaturation<>255 then
    Saturation(Form2.Bmp,pSaturation);
  Form2.Refresh;
end;

procedure TForm3.Button1Click(Sender: TObject);
begin
  sRed.Position:=255;
  sBlue.Position:=255;
  sGreen.Position:=255;
  sContrast.Position:=255;
  sLightness.Position:=255;
  sSaturation.Position:=255;
  Process;
end;

procedure TForm3.FormShow(Sender: TObject);
begin
  Button1.Click;
end;

procedure TForm3.sRedScroll(Sender: TObject; ScrollCode: TScrollCode;
  var ScrollPos: Integer);
begin
  Process;
end;

procedure TForm3.FormHide(Sender: TObject);
begin
  CopyMemory(Form2.Buf.Bits,Form2.Bmp.Bits,Form2.Buf.Size);
end;

end.
